diff --git a/src/lib389/lib389/cli_conf/pwpolicy.py b/src/lib389/lib389/cli_conf/pwpolicy.py
new file mode 100644
index 0000000..dc72965
--- /dev/null
+++ b/src/lib389/lib389/cli_conf/pwpolicy.py
@@ -0,0 +1,198 @@
+# --- BEGIN COPYRIGHT BLOCK ---
+# Copyright (C) 2018 Red Hat, Inc.
+# All rights reserved.
+#
+# License: GPL (version 3 or any later version).
+# See LICENSE for details.
+# --- END COPYRIGHT BLOCK ---
+
+import ldap
+
+arg_to_attr = {
+        'pwdlocal': 'nsslapd-pwpolicy-local',
+        'pwdscheme': 'passwordstoragescheme',
+        'pwdchange': 'passwordChange',
+        'pwdmustchange': 'passwordMustChange',
+        'pwdhistory': 'passwordHistory',
+        'pwdhistorycount': 'passwordInHistory',
+        'pwdadmin': 'passwordAdminDN',
+        'pwdtrack': 'passwordTrackUpdateTime',
+        'pwdwarning': 'passwordWarning',
+        'pwdisglobal': 'passwordIsGlobalPolicy',
+        'pwdexpire': 'passwordExp',
+        'pwdmaxage': 'passwordMaxAge',
+        'pwdminage': 'passwordMinAge',
+        'pwdgracelimit': 'passwordGraceLimit',
+        'pwdsendexpiring': 'passwordSendExpiringTime',
+        'pwdlockout': 'passwordLockout',
+        'pwdunlock': 'passwordUnlock',
+        'pwdlockoutduration': 'passwordLockoutDuration',
+        'pwdmaxfailures': 'passwordMaxFailure',
+        'pwdresetfailcount': 'passwordResetFailureCount',
+        'pwdchecksyntax': 'passwordCheckSyntax',
+        'pwdminlen': 'passwordMinLength',
+        'pwdmindigits': 'passwordMinDigits',
+        'pwdminalphas': 'passwordMinAlphas',
+        'pwdminuppers': 'passwordMinUppers',
+        'pwdminlowers': 'passwordMinLowers',
+        'pwdminspecials': 'passwordMinSpecials',
+        'pwdmin8bits': 'passwordMin8bit',
+        'pwdmaxrepeats': 'passwordMaxRepeats',
+        'pwdpalindrome': 'passwordPalindrome',
+        'pwdmaxseq': 'passwordMaxSequence',
+        'pwdmaxseqsets': 'passwordMaxSeqSets',
+        'pwdmaxclasschars': 'passwordMaxClassChars',
+        'pwdmincatagories': 'passwordMinCategories',
+        'pwdmintokenlen': 'passwordMinTokenLength',
+        'pwdbadwords': 'passwordBadWords',
+        'pwduserattrs': 'passwordUserAttributes',
+        'pwddictcheck': 'passwordDictCheck',
+        'pwddictpath': 'passwordDictPath',
+        'pwdallowhash': 'nsslapd-allow-hashed-passwords'
+    }
+
+
+def list_policies(inst, basedn, log, args):
+    print(inst.pwpolicy.list_policies(args.DN[0], use_json=args.json))
+
+
+def get_local_policy(inst, basedn, log, args):
+    print(inst.pwpolicy.get_pwpolicy(targetdn=args.DN[0], use_json=args.json))
+
+
+def get_global_policy(inst, basedn, log, args):
+    print(inst.pwpolicy.get_pwpolicy(targetdn=None, use_json=args.json))
+
+
+def create_subtree_policy(inst, basedn, log, args):
+    try:
+        inst.pwpolicy.create_subtree_policy(args.DN[0], args, arg_to_attr)
+        print('Successfully created subtree password policy')
+    except ldap.ALREADY_EXISTS:
+        raise ValueError('There is already a subtree password policy created for this entry')
+
+
+def create_user_policy(inst, basedn, log, args):
+    try:
+        inst.pwpolicy.create_user_policy(args.DN[0], args, arg_to_attr)
+        print('Successfully created user password policy')
+    except ldap.ALREADY_EXISTS:
+        raise ValueError('There is already a user password policy created for this entry')
+
+
+def set_global_policy(inst, basedn, log, args):
+    for arg in vars(args):
+        val = getattr(args, arg)
+        if arg in arg_to_attr and val is not None:
+            inst.config.set(arg_to_attr[arg], val)
+    print("Successfully updated global policy")
+
+
+def set_local_policy(inst, basedn, log, args):
+    inst.pwpolicy.set_policy(args.DN[0], args, arg_to_attr)
+    print("Successfully updated local policy")
+
+
+def del_local_policy(inst, basedn, log, args):
+    inst.pwpolicy.delete_local_policy(args.DN[0])
+    print("Successfully removed local password policy")
+
+
+def create_parser(subparsers):
+    # Create our two parsers for local and global policies
+    globalpwp_parser = subparsers.add_parser('pwpolicy', help='Get and set the global password policy settings')
+    localpwp_parser = subparsers.add_parser('localpwp', help='Manage local (user/subtree) password policies')
+
+    ############################################
+    # Local password policies
+    ############################################
+    local_subcommands = localpwp_parser.add_subparsers(help='Local password policy')
+    # List all the local policies
+    list_parser = local_subcommands.add_parser('list', help='List all the local password policies')
+    list_parser.set_defaults(func=list_policies)
+    list_parser.add_argument('DN', nargs=1, help='Suffix to search for local password policies')
+    # Get a local policy
+    get_parser = local_subcommands.add_parser('get', help='Get local password policy entry')
+    get_parser.set_defaults(func=get_local_policy)
+    get_parser.add_argument('DN', nargs=1, help='Get the local policy for this entry DN')
+    # The "set" arguments...
+    set_parser = local_subcommands.add_parser('set', help='Set an attribute in a local password policy')
+    set_parser.set_defaults(func=set_local_policy)
+    # General settings
+    set_parser.add_argument('--pwdscheme', help="The password storage scheme")
+    set_parser.add_argument('--pwdchange', help="Allow users to change their passwords")
+    set_parser.add_argument('--pwdmustchange', help="User must change their passwrod after it is reset by an Administrator")
+    set_parser.add_argument('--pwdhistory', help="To enable password history set this to \"on\", otherwise \"off\"")
+    set_parser.add_argument('--pwdhistorycount', help="The number of password to keep in history")
+    set_parser.add_argument('--pwdadmin', help="The DN of an entry or a group of account that can bypass password policy constraints")
+    set_parser.add_argument('--pwdtrack', help="Set to \"on\" to track the time the password was last changed")
+    set_parser.add_argument('--pwdwarning', help="Send an expiring warning if password expires within this time (in seconds)")
+    # Expiration settings
+    set_parser.add_argument('--pwdexpire', help="Set to \"on\" to enable password expiration")
+    set_parser.add_argument('--pwdmaxage', help="The password expiration time in seconds")
+    set_parser.add_argument('--pwdminage', help="The number of seconds that must pass before a user can change their password")
+    set_parser.add_argument('--pwdgracelimit', help="The number of allowed logins after the password has expired")
+    set_parser.add_argument('--pwdsendexpiring', help="Set to \"on\" to always send the expiring control regardless of the warning period")
+    # Account lockout settings
+    set_parser.add_argument('--pwdlockout', help="Set to \"on\" to enable account lockout")
+    set_parser.add_argument('--pwdunlock', help="Set to \"on\" to allow an account to become unlocked after the lockout duration")
+    set_parser.add_argument('--pwdlockoutduration', help="The number of seconds an account stays locked out")
+    set_parser.add_argument('--pwdmaxfailures', help="The maximum number of allowed failed password attempts beforet the acocunt gets locked")
+    set_parser.add_argument('--pwdresetfailcount', help="The number of secondsto wait before reducingthe failed login count on an account")
+    # Syntax settings
+    set_parser.add_argument('--pwdchecksyntax', help="Set to \"on\" to Enable password syntax checking")
+    set_parser.add_argument('--pwdminlen', help="The minimum number of characters required in a password")
+    set_parser.add_argument('--pwdmindigits', help="The minimum number of digit/number characters in a password")
+    set_parser.add_argument('--pwdminalphas', help="The minimum number of alpha characters required in a password")
+    set_parser.add_argument('--pwdminuppers', help="The minimum number of uppercase characters required in a password")
+    set_parser.add_argument('--pwdminlowers', help="The minimum number of lowercase characters required in a password")
+    set_parser.add_argument('--pwdminspecials', help="The minimum number of special characters required in a password")
+    set_parser.add_argument('--pwdmin8bits', help="The minimum number of 8-bit characters required in a password")
+    set_parser.add_argument('--pwdmaxrepeats', help="The maximum number of times the same character can appear sequentially in the password")
+    set_parser.add_argument('--pwdpalindrome', help="Set to \"on\" to reject passwords that are palindromes")
+    set_parser.add_argument('--pwdmaxseq', help="The maximum number of allowed monotonic character sequences in a password")
+    set_parser.add_argument('--pwdmaxseqsets', help="The maximum number of allowed monotonic character sequences that can be duplicated in a password")
+    set_parser.add_argument('--pwdmaxclasschars', help="The maximum number of sequential characters from the same character class that is allowed in a password")
+    set_parser.add_argument('--pwdmincatagories', help="The minimum number of syntax catagory checks")
+    set_parser.add_argument('--pwdmintokenlen', help="Sets the smallest attribute value length that is used for trivial/user words checking.  This also impacts \"--pwduserattrs\"")
+    set_parser.add_argument('--pwdbadwords', help="A space-separated list of words that can not be in a password")
+    set_parser.add_argument('--pwduserattrs', help="A space-separated list of attributes whose values can not appear in the password (See \"--pwdmintokenlen\")")
+    set_parser.add_argument('--pwddictcheck', help="Set to \"on\" to enfore CrackLib dictionary checking")
+    set_parser.add_argument('--pwddictpath', help="Filesystem path to specific/custom CrackLib dictionary files")
+    # delete local password policy
+    del_parser = local_subcommands.add_parser('remove', help='Remove a local password policy')
+    del_parser.set_defaults(func=del_local_policy)
+    del_parser.add_argument('DN', nargs=1, help='Remove local policy for this entry DN')
+    #
+    # create USER local password policy
+    #
+    add_user_parser = local_subcommands.add_parser('adduser', add_help=False, parents=[set_parser], help='Add new user password policy')
+    add_user_parser.set_defaults(func=create_user_policy)
+    #
+    # create SUBTREE local password policy
+    #
+    add_subtree_parser = local_subcommands.add_parser('addsubtree', add_help=False, parents=[set_parser], help='Add new subtree password policy')
+    add_subtree_parser.set_defaults(func=create_subtree_policy)
+
+    ###########################################
+    # The global policy (cn=config)
+    ###########################################
+    global_subcommands = globalpwp_parser.add_subparsers(help='Global password policy')
+    # Get policy
+    get_global_parser = global_subcommands.add_parser('get', help='Get the global password policy entry')
+    get_global_parser.set_defaults(func=get_global_policy)
+    # Set policy
+    set_global_parser = global_subcommands.add_parser('set', add_help=False, parents=[set_parser],
+                                                      help='Set an attribute in a global password policy')
+    set_global_parser.set_defaults(func=set_global_policy)
+    set_global_parser.add_argument('--pwdlocal', help="Set to \"on\" to enable fine-grained (subtree/user-level) password policies")
+    set_global_parser.add_argument('--pwdisglobal', help="Set to \"on\" to enable password policy state attributesto be replicated")
+    set_global_parser.add_argument('--pwdallowhash', help="Set to \"on\" to allow adding prehashed passwords")
+
+    #############################################
+    # Wrap it up.  Now that we copied all the parent arugments to the subparsers,
+    # and the DN argument needed only by the local policies
+    #############################################
+    set_parser.add_argument('DN', nargs=1, help='Set the local policy for this entry DN')
+    add_subtree_parser.add_argument('DN', nargs=1, help='Add/replace the subtree policy for this entry DN')
+    add_user_parser.add_argument('DN', nargs=1, help='Add/replace the local password policy for this entry DN')
\ No newline at end of file
diff --git a/src/lib389/lib389/cli_conf/schema.py b/src/lib389/lib389/cli_conf/schema.py
index 93e0716..11dcc20 100644
--- a/src/lib389/lib389/cli_conf/schema.py
+++ b/src/lib389/lib389/cli_conf/schema.py
@@ -91,14 +91,14 @@ def create_parser(subparsers):
 
     subcommands = schema_parser.add_subparsers(help='schema')
 
-    list_attributetype_parser = subcommands.add_parser('list_attributetype', help='List avaliable attribute types on this system')
+    list_attributetype_parser = subcommands.add_parser('list_attributetype', help='List available attribute types on this system')
     list_attributetype_parser.set_defaults(func=list_attributetype)
 
     query_attributetype_parser = subcommands.add_parser('query_attributetype', help='Query an attribute to determine object classes that may or must take it')
     query_attributetype_parser.set_defaults(func=query_attributetype)
     query_attributetype_parser.add_argument('attr', nargs='?', help='Attribute type to query')
 
-    list_objectclass_parser = subcommands.add_parser('list_objectclasses', help='List avaliable objectclasses on this system')
+    list_objectclass_parser = subcommands.add_parser('list_objectclasses', help='List available objectclasses on this system')
     list_objectclass_parser.set_defaults(func=list_objectclasses)
 
     query_objectclass_parser = subcommands.add_parser('query_objectclass', help='Query an objectclass')
@@ -110,7 +110,7 @@ def create_parser(subparsers):
     reload_parser.add_argument('-d', '--schemadir', help="directory where schema files are located")
     reload_parser.add_argument('--wait', action='store_true', default=False, help="Wait for the reload task to complete")
 
-    list_matchingrules_parser = subcommands.add_parser('list_matchingrules', help='List avaliable matching rules on this system')
+    list_matchingrules_parser = subcommands.add_parser('list_matchingrules', help='List available matching rules on this system')
     list_matchingrules_parser.set_defaults(func=list_matchingrules)
 
     query_matchingrule_parser = subcommands.add_parser('query_matchingrule', help='Query a matchingrule')
diff --git a/src/lib389/lib389/pwpolicy.py b/src/lib389/lib389/pwpolicy.py
new file mode 100644
index 0000000..cf3fc59
--- /dev/null
+++ b/src/lib389/lib389/pwpolicy.py
@@ -0,0 +1,347 @@
+# --- BEGIN COPYRIGHT BLOCK ---
+# Copyright (C) 2018 Red Hat, Inc.
+# All rights reserved.
+#
+# License: GPL (version 3 or any later version).
+# See LICENSE for details.
+# --- END COPYRIGHT BLOCK ---
+
+import ldap
+import json
+from ldap import modlist
+from lib389.utils import ensure_str, ensure_list_str, ensure_bytes
+
+USER_POLICY = 1
+SUBTREE_POLICY = 2
+
+
+class Pwpolicy(object):
+    """A local password policy, either user or subtree
+
+    :param instance: An instance
+    :type instance: lib389.DirSrv
+    :param dn: Entry DN
+    :type dn: str
+
+
+    cn=nsPwPolicyEntry,DN_OF_ENTRY,cn=nsPwPolicyContainer,SUFFIX
+
+    """
+
+    def __init__(self, conn):
+        self.conn = conn
+        self.log = conn.log
+        self.pwp_attributes = [
+            'passwordstoragescheme',
+            'passwordChange',
+            'passwordMustChange',
+            'passwordHistory',
+            'passwordInHistory',
+            'passwordAdminDN',
+            'passwordTrackUpdateTime',
+            'passwordWarning',
+            'passwordMaxAge',
+            'passwordMinAge',
+            'passwordExp',
+            'passwordGraceLimit',
+            'passwordSendExpiringTime',
+            'passwordLockout',
+            'passwordUnlock',
+            'passwordMaxFailure',
+            'passwordLockoutDuration',
+            'passwordResetFailureCount',
+            'passwordCheckSyntax',
+            'passwordMinLength',
+            'passwordMinDigits',
+            'passwordMinAlphas',
+            'passwordMinUppers',
+            'passwordMinLowers',
+            'passwordMinSpecials',
+            'passwordMaxRepeats',
+            'passwordMin8bit',
+            'passwordMinCategories',
+            'passwordMinTokenLength',
+            'passwordDictPath',
+            'passwordDictCheck',
+            'passwordPalindrome',
+            'passwordMaxSequence',
+            'passwordMaxClassChars',
+            'passwordMaxSeqSets',
+            'passwordBadWords',
+            'passwordUserAttributes',
+            'passwordIsGlobalPolicy',
+            'nsslapd-pwpolicy-local',
+            'nsslapd-allow-hashed-passwords'
+        ]
+
+    def create_pwp_container(self, basedn):
+        attrs = {'objectclass': [b'top', b'nsContainer'],
+                 'cn': [b'nsPwPolicyContainer']}
+        ldif = modlist.addModlist(attrs)
+        try:
+            self.conn.add_ext_s(basedn, ldif)
+        except ldap.ALREADY_EXISTS:
+            # Already exists, no problem
+            pass
+
+    def create_user_policy(self, targetdn, args, arg_to_attr):
+        """Create a local user password policy entry
+        """
+
+        # Verify target dn exists before getting started
+        try:
+            self.conn.search_s(targetdn, ldap.SCOPE_BASE, "objectclass=*")
+        except ldap.NO_SUCH_OBJECT:
+            raise ValueError('Can not create user password policy because the target dn does not exist')
+
+        rdns = ldap.dn.explode_dn(targetdn)
+        rdns.pop(0)
+        parentdn = ",".join(rdns)
+
+        # Create the pwp container if needed
+        self.create_pwp_container("cn=nsPwPolicyContainer,{}".format(parentdn))
+
+        # Gather the attributes and create policy entry
+        attrs = {}
+        for arg in vars(args):
+            val = getattr(args, arg)
+            if arg in arg_to_attr and val is not None:
+                attrs[arg_to_attr[arg]] = ensure_bytes(val)
+        attrs['objectclass'] = [b'top', b'ldapsubentry', b'passwordpolicy']
+        ldif = modlist.addModlist(attrs)
+        user_dn = 'cn="cn=nsPwPolicyEntry,{}",cn=nsPwPolicyContainer,{}'.format(targetdn, parentdn)
+        self.conn.add_ext_s(user_dn, ldif)
+
+        # Add policy to entry
+        self.conn.modify_s(targetdn, [(ldap.MOD_REPLACE, 'pwdpolicysubentry', ensure_bytes(user_dn))])
+
+    def create_subtree_policy(self, targetdn, args, arg_to_attr):
+        """Create a local subtree password policy entry - requires COS entry
+        """
+
+        # Verify target dn exists before getting started
+        try:
+            self.conn.search_s(targetdn, ldap.SCOPE_BASE, "objectclass=*")
+        except ldap.NO_SUCH_OBJECT:
+            raise ValueError('Can not create user password policy because the target dn does not exist')
+
+        # Create the pwp container if needed
+        container_dn = "cn=nsPwPolicyContainer,{}".format(targetdn)
+        self.create_pwp_container(container_dn)
+
+        # Create COS entries
+        cos_template_entry = 'cn=nsPwTemplateEntry,{}'.format(targetdn)
+        cos_template_dn = 'cn="cn=nsPwTemplateEntry,{}",{}'.format(targetdn, container_dn)
+        cos_subentry_dn = 'cn="cn=nsPwPolicyEntry,{}",{}'.format(targetdn, container_dn)
+        cos_template_attrs = {'cosPriority': b'1', 'pwdpolicysubentry': ensure_bytes(cos_subentry_dn),
+                              'cn': ensure_bytes(cos_template_entry)}
+
+        cos_template_attrs['objectclass'] = [b'top', b'ldapsubentry', b'extensibleObject', b'costemplate']
+        ldif = modlist.addModlist(cos_template_attrs)
+        self.conn.add_ext_s(cos_template_dn, ldif)
+
+        cos_def_attrs = {'objectclass': [b'top', b'ldapsubentry', b'extensibleObject',
+                                         b'cosSuperDefinition', b'cosPointerDefinition'],
+                         'cosAttribute': b'pwdpolicysubentry default operational',
+                         'cosTemplateDn': ensure_bytes(cos_template_dn),
+                         'cn': b'nsPwPolicy_CoS'}
+        ldif = modlist.addModlist(cos_def_attrs)
+        self.conn.add_ext_s("cn=nsPwPolicy_CoS,{}".format(targetdn), ldif)
+
+        # Gather the attributes and create policy sub entry
+        attrs = {}
+        for arg in vars(args):
+            val = getattr(args, arg)
+            if arg in arg_to_attr and val is not None:
+                attrs[arg_to_attr[arg]] = ensure_bytes(val)
+        attrs['objectclass'] = [b'top', b'ldapsubentry', b'passwordpolicy']
+        ldif = modlist.addModlist(attrs)
+        try:
+            self.conn.add_ext_s(cos_subentry_dn, ldif)
+        except ldap.ALREADY_EXISTS:
+            # Already exists, no problem
+            pass
+
+        # Add policy to entry
+        self.conn.modify_s(targetdn, [(ldap.MOD_REPLACE, 'pwdpolicysubentry', ensure_bytes(cos_subentry_dn))])
+
+    def delete_local_policy(self, targetdn):
+        container_dn = "cn=nsPwPolicyContainer,{}".format(targetdn)
+
+        # First check that the entry exists
+        try:
+            entries = self.conn.search_s(targetdn, ldap.SCOPE_BASE, 'objectclass=top', ['pwdpolicysubentry'])
+            target_entry = entries[0]
+        except ldap.NO_SUCH_OBJECT:
+            raise ValueError('The entry does not exist, nothing to remove')
+
+        # Subtree or local policy?
+        try:
+            cos_def_dn = 'cn=nsPwPolicy_CoS,{}'.format(targetdn)
+            self.conn.search_s(cos_def_dn, ldap.SCOPE_BASE, "(|(objectclass=ldapsubentry)(objectclass=*))")
+            found_subtree = True
+        except:
+            found_subtree = False
+
+        # If subtree policy then remove COS template and definition
+        if found_subtree:
+            container_dn = "cn=nsPwPolicyContainer,{}".format(targetdn)
+            cos_template_dn = 'cn="cn=nsPwTemplateEntry,{}",{}'.format(targetdn, container_dn)
+            policy_dn = 'cn="cn=nsPwPolicyEntry,{}",{}'.format(targetdn, container_dn)
+            self.conn.delete_s(cos_template_dn)
+            self.conn.delete_s(policy_dn)
+            self.conn.delete_s(cos_def_dn)
+        else:
+            # Remove password subentry from target DN, then remove the policy entry itself
+            rdns = ldap.dn.explode_dn(targetdn)
+            rdns.pop(0)
+            parentdn = ",".join(rdns)
+            container_dn = "cn=nsPwPolicyContainer,{}".format(parentdn)
+            policy_dn = target_entry.getValue('pwdpolicysubentry')
+            if policy_dn is None or policy_dn == "":
+                raise ValueError('There is no local password policy for this entry')
+            self.conn.delete_s(ensure_str(policy_dn))
+
+        # Remove the passwordPolicySubentry from the target
+        self.conn.modify_s(targetdn, [(ldap.MOD_DELETE, 'pwdpolicysubentry', None)])
+
+        # if there are no other entries under the container, then remove the container
+        entries = self.conn.search_s(container_dn, ldap.SCOPE_SUBTREE, "(|(objectclass=ldapsubentry)(objectclass=*))")
+        if len(entries) == 1:
+            self.conn.delete_s(container_dn)
+
+    def get_pwpolicy(self, targetdn=None, use_json=False):
+        """Get the local or global password policy entry"""
+        global_policy = False
+        policy_type = "global"
+        if targetdn is not None:
+            # Local policy listed by name
+            entrydn = 'cn="cn=nsPwPolicyEntry,{}",cn=nsPwPolicyContainer,{}'.format(targetdn, targetdn)
+            pwp_attributes = self.pwp_attributes
+        else:
+            # Global policy
+            global_policy = True
+            entrydn = "cn=config"
+            pwp_attributes = self.pwp_attributes
+            pwp_attributes += ['passwordIsGlobalPolicy', 'nsslapd-pwpolicy_local']
+
+        try:
+            entries = self.conn.search_s(entrydn,
+                                         ldap.SCOPE_BASE,
+                                         'objectclass=*',
+                                         pwp_attributes)
+            entry = entries[0]
+        except ldap.NO_SUCH_OBJECT:
+            # okay lets see if its auser policy
+            rdns = ldap.dn.explode_dn(targetdn)
+            rdns.pop(0)
+            parentdn = (",").join(rdns)
+            entrydn = 'cn="cn=nsPwPolicyEntry,{}",cn=nsPwPolicyContainer,{}'.format(targetdn, parentdn)
+            try:
+                entries = self.conn.search_s(entrydn,
+                                             ldap.SCOPE_BASE,
+                                             'objectclass=*',
+                                             pwp_attributes)
+                entry = entries[0]
+            except ldap.LDAPError as e:
+                raise ValueError("Could not find password policy for entry: {} Error: {}".format(targetdn, str(e)))
+        except ldap.LDAPError as e:
+            raise ValueError("Could not find password policy for entry: {} Error: {}".format(targetdn, str(e)))
+
+        if not global_policy:
+            # subtree or user policy?
+            cos_dn = 'cn=nspwpolicy_cos,' + targetdn
+            try:
+                self.conn.search_s(cos_dn, ldap.SCOPE_BASE, "(|(objectclass=ldapsubentry)(objectclass=*))")
+                policy_type = "Subtree"
+            except:
+                policy_type = "User"
+
+        if use_json:
+            str_attrs = {}
+            for k in entry.data:
+                str_attrs[ensure_str(k)] = ensure_list_str(entry.data[k])
+
+            # ensure all the keys are lowercase
+            str_attrs = dict((k.lower(), v) for k, v in str_attrs.items())
+
+            response = json.dumps({"type": "entry", "pwp_type": policy_type, "dn": ensure_str(targetdn), "attrs": str_attrs})
+        else:
+            if global_policy:
+                response = "Global Password Policy: cn=config\n------------------------------------\n"
+            else:
+                response = "Local {} Policy: {}\n------------------------------------\n".format(policy_type, targetdn)
+            for k in entry.data:
+                response += "{}: {}\n".format(k, ensure_str(entry.data[k][0]))
+
+        return response
+
+    def list_policies(self, targetdn, use_json=False):
+        """Return a list of the target DN's of all user policies
+        """
+
+        if use_json:
+            result = {'type': 'list', 'items': []}
+        else:
+            result = ""
+
+        # First get all the policies
+        policies = self.conn.search_s(targetdn, ldap.SCOPE_SUBTREE, "(&(objectclass=ldapsubentry)(objectclass=passwordpolicy))", ['cn'])
+        if policies is None or len(policies) == 0:
+            if use_json:
+                return json.dumps(result)
+            else:
+                return "No local password polices found"
+
+        # Determine if the policy is subtree or user (subtree policies have COS entries)
+        for policy in policies:
+            cn = ensure_str(policy.getValue('cn'))
+            entrydn = cn.lower().replace('cn=nspwpolicyentry,', '')   # .lstrip()
+            cos_dn = cn.lower().replace('cn=nspwpolicyentry', 'cn=nspwpolicy_cos')
+            try:
+                self.conn.search_s(cos_dn, ldap.SCOPE_BASE, "(|(objectclass=ldapsubentry)(objectclass=*))")
+                found_subtree = True
+            except:
+                found_subtree = False
+
+            if found_subtree:
+                # Build subtree policy list
+                if use_json:
+                    result['items'].append([entrydn, "Subtree Policy"])
+                else:
+                    result += entrydn + " (subtree policy)\n"
+            else:
+                # Build user policy list
+                if use_json:
+                    result['items'].append([entrydn, "User Policy"])
+                else:
+                    result += entrydn + " (user policy)\n"
+
+        if use_json:
+            return json.dumps(result)
+        else:
+            return result
+
+    def set_policy(self, targetdn, args, arg_to_attr):
+        '''This could be a user or subtree policy, so find out which one and
+        use the correct container dn'''
+        try:
+            cos_def_dn = 'cn=nsPwPolicy_CoS,{}'.format(targetdn)
+            self.conn.search_s(cos_def_dn, ldap.SCOPE_BASE, "(|(objectclass=ldapsubentry)(objectclass=*))")
+            # This is a subtree policy
+            container_dn = "cn=nsPwPolicyContainer,{}".format(targetdn)
+        except:
+            # This is a user policy
+            rdns = ldap.dn.explode_dn(targetdn)
+            rdns.pop(0)
+            parentdn = ",".join(rdns)
+            container_dn = "cn=nsPwPolicyContainer,{}".format(parentdn)
+
+        policy_dn = 'cn="cn=nsPwPolicyEntry,{}",{}'.format(targetdn, container_dn)
+        mods = []
+        for arg in vars(args):
+            val = getattr(args, arg)
+            if arg in arg_to_attr and val is not None:
+                mods.append((ldap.MOD_REPLACE, ensure_str(arg_to_attr[arg]), ensure_bytes(val)))
+        if len(mods) > 0:
+            self.conn.modify_s(policy_dn, mods)

